
#include "UmlItem.h"
#include "UmlClass.h"

#include <qvector.h>
#include "UmlPackage.h"
#include "UmlCom.h"

 UmlItem::~UmlItem() {
}

void UmlItem::genCxxTestCase() {
UmlCom::trace("Target not allowed, must be a <i>Class</i><hr>");
}

void UmlItem::genGlobalFixture() {
  UmlCom::trace("GenGlobalFixture operation can only be applied to a class view");
}

bool UmlItem::genTest(UmlClass * testClass) {
UmlCom::trace("the target of genTest must be of type UmlOperation");
return true;
}

UmlItem* UmlItem::searchFor(anItemKind k, QCString s)
{
return UmlBasePackage::getProject()->searchForInternal(k, s);
}

UmlItem* UmlItem::searchFor(anItemKind k)
{
return UmlBasePackage::getProject()->searchForInternal(k);
}

void UmlItem::searchForAll(anItemKind k, QVector<UmlItem> & itemsFound)
{
UmlBasePackage::getProject()->searchForAllInternal(k, itemsFound);
}

UmlItem* UmlItem::searchForInternal(anItemKind k, QCString s) {
  if ((kind() == k) && (name() == s)){
    return this;
  }else {
    const QVector<UmlItem> ch = children();

    for (unsigned i = 0; i != ch.size(); i += 1) {
      UmlItem * result = ch[i]->searchForInternal(k, s);

      if (result != 0)
        return result;
    }

    return (UmlItem *)0;
  }
}

UmlItem* UmlItem::searchForInternal(anItemKind k) {
  if ((kind() == k)){
    return this;
  }else {
    const QVector<UmlItem> ch = children();

    for (unsigned i = 0; i != ch.size(); i += 1) {
      UmlItem * result = ch[i]->searchForInternal(k);

      if (result != 0)
        return result;
    }

    return (UmlItem *)0;
  }
}

void UmlItem::searchForAllInternal(anItemKind k, QVector<UmlItem> & itemsFound) {
  if ((kind() == k)){
    itemsFound.insert(itemsFound.count(), this);
  }else {
    const QVector<UmlItem> ch = children();
    if( !ch.isNull() ){
      for (unsigned i = 0; i != ch.count(); i += 1) {
        ch[i]->searchForAllInternal(k, itemsFound);
      }
    }
  }
}

