#ifndef _UMLITEM_H
#define _UMLITEM_H


#include "UmlBaseItem.h"
#include <qcstring.h>
#include "anItemKind.h"
#include <qvector.h>

class UmlClass;

// This class is a mother class for all the other Uml* classes, this
// allows to generalize their management, declare virtual operations etc ...
//
// You can modify it as you want (except the constructor)
class UmlItem : public UmlBaseItem {
  public:
    UmlItem(void * id, const QCString & n) : UmlBaseItem(id, n) {};

    virtual ~UmlItem();

    //Generate a CxxTestCase class for the selected class in browser
    virtual void genCxxTestCase();

    virtual void genGlobalFixture();

    //Generate a test for an operation of a class
    virtual bool genTest(UmlClass * testClass);

    static UmlItem* searchFor(anItemKind k, QCString s);

    static UmlItem* searchFor(anItemKind k);

    static void searchForAll(anItemKind k, QVector<UmlItem> & itemsFound);

    virtual UmlItem* searchForInternal(anItemKind k, QCString s);

    virtual UmlItem* searchForInternal(anItemKind k);

    virtual void searchForAllInternal(anItemKind k, QVector<UmlItem> & itemsFound);

};

#endif
