
#include <qvariant.h>
#include <qstring.h>
#include "UmlCom.h"
#include "frmgencxxtest.h"

//
// *  Constructs a FrmGenCxxTest as a child of 'parent', with the
// *  name 'name' and widget flags set to 'f'.
// *
// *  The dialog will by default be modeless, unless you set 'modal' to
// *  TRUE to construct a modal dialog.
// 

FrmGenCxxTest::FrmGenCxxTest(QWidget * parent, const char * name, bool modal, WFlags fl)
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "FrmGenCxxTest" );
    setMinimumSize( QSize( 100, 100 ) );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 10, 10, 293, 31 ) );

    textLabel1_3 = new QLabel( this, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 20, 50, 80, 31 ) );

    textLabel1_2 = new QLabel( this, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 20, 100, 120, 31 ) );

    cmdGenerate = new QPushButton( this, "cmdGenerate" );
    cmdGenerate->setGeometry( QRect( 70, 190, 121, 40 ) );
    cmdGenerate->setDefault( TRUE );

    cmdCancel = new QPushButton( this, "cmdCancel" );
    cmdCancel->setGeometry( QRect( 210, 190, 121, 41 ) );

    cboDeploymentView = new QComboBox( FALSE, this, "cboDeploymentView" );
    cboDeploymentView->setGeometry( QRect( 140, 100, 250, 30 ) );

    cboClassView = new QComboBox( FALSE, this, "cboClassView" );
    cboClassView->setGeometry( QRect( 140, 50, 250, 30 ) );

    chkGenFixture = new QCheckBox( this, "chkGenFixture" );
    chkGenFixture->setGeometry( QRect( 20, 140, 200, 41 ) );

    languageChange();

    resize( QSize(400, 243).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( cmdCancel, SIGNAL( clicked() ), this, SLOT( cmdCancel_clicked() ) );
    connect( cmdGenerate, SIGNAL( clicked() ), this, SLOT( cmdGenerate_clicked() ) );

    // tab order
    setTabOrder( cboClassView, cboDeploymentView );
    setTabOrder( cboDeploymentView, chkGenFixture );
    setTabOrder( chkGenFixture, cmdGenerate );
    setTabOrder( cmdGenerate, cmdCancel );
    init();
}

//
// *  Destroys the object and frees any allocated resources
// 

FrmGenCxxTest::~FrmGenCxxTest(){
    destroy();
    // no need to delete child widgets, Qt does it all for us
}

void FrmGenCxxTest::destroy() {

}

void FrmGenCxxTest::setViews(QVector<UmlItem> & clsViews, QVector<UmlItem> & depViews) {
	unsigned int i;    
	for(i =0; i < clsViews.count(); i++){
	    cboClassView->insertItem( QString(clsViews[i]->name()) );
	}
    
	for(i =0; i < depViews.count(); i++){
	    cboDeploymentView->insertItem( QString(depViews[i]->name()) );
	}
	
}

void FrmGenCxxTest::setSelectedViews(int & clsViewIndex, int & depViewIndex) {
  // TODO: search the combo box for matching name
  
  // TODO: set it selected	
}

//***************************************************************************
//** ui.h extension file, included from the uic-generated form implementation.
//**
//** If you want to add, delete, or rename functions or slots, use
//** Qt Designer to update this file, preserving your code.
//**
//** You should not define a constructor or destructor in this file.
//** Instead, write your code in functions called init() and destroy().
//** These will automatically be called by the form's constructor and
//** destructor.
//****************************************************************************

void FrmGenCxxTest::cmdCancel_clicked() {
    
    reject();
}

void FrmGenCxxTest::cmdGenerate_clicked() {
    //TODO: do the dialog processing
    
    accept();
}

void FrmGenCxxTest::languageChange() {
    setCaption( tr( "Generate CxxTests" ) );
    textLabel1->setText( tr( "Generate the test class(es) and artifact(s) in :" ) );
    textLabel1_3->setText( tr( "Class View" ) );
    textLabel1_2->setText( tr( "Deployment View" ) );
    cmdGenerate->setText( tr( "&Generate" ) );
    cmdGenerate->setAccel( ALT+int('G') );
    cmdCancel->setText( tr( "&Cancel" ) );
    cmdCancel->setAccel( ALT+int('C') );
    chkGenFixture->setText( tr( "Generate Test Fixture" ) );
}

void FrmGenCxxTest::init() {
    
}

